Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1975)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1976)
@@ -1043,504 +1043,463 @@
 !> Solver for the energy balance at the surface.
 !------------------------------------------------------------------------------!
-    SUBROUTINE lsm_energy_balance
-
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  i         !< running index
-       INTEGER(iwp) ::  j         !< running index
-       INTEGER(iwp) ::  k, ks     !< running index
-
-       REAL(wp) :: c_surface_tmp,& !< temporary variable for storing the volumetric heat capacity of the surface
-                   f1,          & !< resistance correction term 1
-                   f2,          & !< resistance correction term 2
-                   f3,          & !< resistance correction term 3
-                   m_min,       & !< minimum soil moisture
-                   e,           & !< water vapour pressure
-                   e_s,         & !< water vapour saturation pressure
-                   e_s_dt,      & !< derivate of e_s with respect to T
-                   tend,        & !< tendency
-                   dq_s_dt,     & !< derivate of q_s with respect to T
-                   coef_1,      & !< coef. for prognostic equation
-                   coef_2,      & !< coef. for prognostic equation
-                   f_qsws,      & !< factor for qsws_eb
-                   f_qsws_veg,  & !< factor for qsws_veg_eb
-                   f_qsws_soil, & !< factor for qsws_soil_eb
-                   f_qsws_liq,  & !< factor for qsws_liq_eb
-                   f_shf,       & !< factor for shf_eb
-                   lambda_surface, & !< Current value of lambda_surface
-                   m_liq_eb_max,   & !< maxmimum value of the liq. water reservoir
-                   pt1,         & !< potential temperature at first grid level
-                   qv1            !< specific humidity at first grid level
-
-!
-!--    Calculate the exner function for the current time step
-       exn = ( surface_pressure / 1000.0_wp )**0.286_wp
-
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             k = nzb_s_inner(j,i)
-
-!
-!--          Set lambda_surface according to stratification between skin layer and soil
-             IF (  .NOT.  pave_surface(j,i) )  THEN
-
-                c_surface_tmp = c_surface
-
-                IF ( t_surface(j,i) >= t_soil(nzb_soil,j,i))  THEN
-                   lambda_surface = lambda_surface_s(j,i)
-                ELSE
-                   lambda_surface = lambda_surface_u(j,i)
-                ENDIF
+ SUBROUTINE lsm_energy_balance
+
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  i         !< running index
+    INTEGER(iwp) ::  j         !< running index
+    INTEGER(iwp) ::  k, ks     !< running index
+
+    REAL(wp) :: c_surface_tmp,& !< temporary variable for storing the volumetric heat capacity of the surface
+                f1,          & !< resistance correction term 1
+                f2,          & !< resistance correction term 2
+                f3,          & !< resistance correction term 3
+                m_min,       & !< minimum soil moisture
+                e,           & !< water vapour pressure
+                e_s,         & !< water vapour saturation pressure
+                e_s_dt,      & !< derivate of e_s with respect to T
+                tend,        & !< tendency
+                dq_s_dt,     & !< derivate of q_s with respect to T
+                coef_1,      & !< coef. for prognostic equation
+                coef_2,      & !< coef. for prognostic equation
+                f_qsws,      & !< factor for qsws_eb
+                f_qsws_veg,  & !< factor for qsws_veg_eb
+                f_qsws_soil, & !< factor for qsws_soil_eb
+                f_qsws_liq,  & !< factor for qsws_liq_eb
+                f_shf,       & !< factor for shf_eb
+                lambda_surface, & !< Current value of lambda_surface
+                m_liq_eb_max,   & !< maxmimum value of the liq. water reservoir
+                pt1,         & !< potential temperature at first grid level
+                qv1            !< specific humidity at first grid level
+
+!
+!-- Calculate the exner function for the current time step
+    exn = ( surface_pressure / 1000.0_wp )**0.286_wp
+
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
+          k = nzb_s_inner(j,i)
+
+!
+!--       Set lambda_surface according to stratification between skin layer and soil
+          IF (  .NOT.  pave_surface(j,i) )  THEN
+
+             c_surface_tmp = c_surface
+
+             IF ( t_surface(j,i) >= t_soil(nzb_soil,j,i))  THEN
+                lambda_surface = lambda_surface_s(j,i)
              ELSE
-
-                c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
-                lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
-
+                lambda_surface = lambda_surface_u(j,i)
              ENDIF
-
-!
-!--          First step: calculate aerodyamic resistance. As pt, us, ts
-!--          are not available for the prognostic time step, data from the last
-!--          time step is used here. Note that this formulation is the
-!--          equivalent to the ECMWF formulation using drag coefficients
-             IF ( cloud_physics )  THEN
-                pt1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
-                qv1 = q(k+1,j,i) - ql(k+1,j,i)
-             ELSE
-                pt1 = pt(k+1,j,i)
-                qv1 = q(k+1,j,i)
-             ENDIF
-
-             r_a(j,i) = (pt1 - pt(k,j,i)) / (ts(j,i) * us(j,i) + 1.0E-20_wp)
-
-!
-!--          Make sure that the resistance does not drop to zero for neutral 
-!--          stratification
-             IF ( ABS(r_a(j,i)) < 1.0_wp )  r_a(j,i) = 1.0_wp
-
-!
-!--          Second step: calculate canopy resistance r_canopy
-!--          f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
+          ELSE
+
+             c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
+             lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
+
+          ENDIF
+
+!
+!--       First step: calculate aerodyamic resistance. As pt, us, ts
+!--       are not available for the prognostic time step, data from the last
+!--       time step is used here. Note that this formulation is the
+!--       equivalent to the ECMWF formulation using drag coefficients
+          IF ( cloud_physics )  THEN
+             pt1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
+             qv1 = q(k+1,j,i) - ql(k+1,j,i)
+          ELSE
+             pt1 = pt(k+1,j,i)
+             qv1 = q(k+1,j,i)
+          ENDIF
+
+          r_a(j,i) = (pt1 - pt(k,j,i)) / (ts(j,i) * us(j,i) + 1.0E-20_wp)
+
+!
+!--       Make sure that the resistance does not drop to zero for neutral 
+!--       stratification
+          IF ( ABS(r_a(j,i)) < 1.0_wp )  r_a(j,i) = 1.0_wp
+
+!
+!--       Second step: calculate canopy resistance r_canopy
+!--       f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
  
-!--          f1: correction for incoming shortwave radiation (stomata close at 
-!--          night)
-             IF ( radiation_scheme /= 'constant' )  THEN
-                f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k,j,i) + 0.05_wp ) /  &
-                              (0.81_wp * (0.004_wp * rad_sw_in(k,j,i)          &
-                               + 1.0_wp)) )
-             ELSE
-                f1 = 1.0_wp
-             ENDIF
-
-
-!
-!--          f2: correction for soil moisture availability to plants (the 
-!--          integrated soil moisture must thus be considered here)
-!--          f2 = 0 for very dry soils
-             m_total = 0.0_wp
-             DO  ks = nzb_soil, nzt_soil
-                 m_total = m_total + root_fr(ks,j,i)                           &
-                           * MAX(m_soil(ks,j,i),m_wilt(j,i))
-             ENDDO 
-
-             IF ( m_total > m_wilt(j,i)  .AND.  m_total < m_fc(j,i) )  THEN
-                f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
-             ELSEIF ( m_total >= m_fc(j,i) )  THEN
-                f2 = 1.0_wp
-             ELSE
-                f2 = 1.0E-20_wp
-             ENDIF
-
-!
-!--          Calculate water vapour pressure at saturation 
-             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface(j,i)     &
-                           - 273.16_wp ) / ( t_surface(j,i) - 35.86_wp ) )
-
-!
-!--          f3: correction for vapour pressure deficit
-             IF ( g_d(j,i) /= 0.0_wp )  THEN
-!
-!--             Calculate vapour pressure
-                e  = qv1 * surface_pressure / 0.622_wp
-                f3 = EXP ( -g_d(j,i) * (e_s - e) )
-             ELSE
-                f3 = 1.0_wp
-             ENDIF
-
-!
-!--          Calculate canopy resistance. In case that c_veg is 0 (bare soils),
-!--          this calculation is obsolete, as r_canopy is not used below.
-!--          To do: check for very dry soil -> r_canopy goes to infinity
-             r_canopy(j,i) = r_canopy_min(j,i) / (lai(j,i) * f1 * f2 * f3      &
-                                             + 1.0E-20_wp)
-
-!
-!--          Third step: calculate bare soil resistance r_soil. The Clapp & 
-!--          Hornberger parametrization does not consider c_veg.
-             IF ( soil_type_2d(j,i) /= 7 )  THEN
-                m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *     &
-                        m_res(j,i)
-             ELSE
-                m_min = m_wilt(j,i)
-             ENDIF
-
-             f2 = ( m_soil(nzb_soil,j,i) - m_min ) / ( m_fc(j,i) - m_min )
-             f2 = MAX(f2,1.0E-20_wp)
-             f2 = MIN(f2,1.0_wp)
-
-             r_soil(j,i) = r_soil_min(j,i) / f2
-
-!
-!--          Calculate the maximum possible liquid water amount on plants and
-!--          bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
-!--          assumed, while paved surfaces might hold up 1 mm of water. The 
-!--          liquid water fraction for paved surfaces is calculated after 
-!--          Noilhan & Planton (1989), while the ECMWF formulation is used for
-!--          vegetated surfaces and bare soils.
-             IF ( pave_surface(j,i) )  THEN
-                m_liq_eb_max = m_max_depth * 5.0_wp
-                c_liq(j,i) = MIN( 1.0_wp, (m_liq_eb(j,i) / m_liq_eb_max)**0.67 )
-             ELSE
-                m_liq_eb_max = m_max_depth * ( c_veg(j,i) * lai(j,i)           &
-                               + (1.0_wp - c_veg(j,i)) )
-                c_liq(j,i) = MIN( 1.0_wp, m_liq_eb(j,i) / m_liq_eb_max )
-             ENDIF
-
-!
-!--          Calculate saturation specific humidity
-             q_s = 0.622_wp * e_s / surface_pressure
-
-!
-!--          In case of dewfall, set evapotranspiration to zero
-!--          All super-saturated water is then removed from the air
-             IF ( humidity  .AND.  q_s <= qv1 )  THEN
-                r_canopy(j,i) = 0.0_wp
-                r_soil(j,i)   = 0.0_wp
-             ENDIF
-
-!
-!--          Calculate coefficients for the total evapotranspiration 
-!--          In case of water surface, set vegetation and soil fluxes to zero.
-!--          For pavements, only evaporation of liquid water is possible.
-             IF ( water_surface(j,i) )  THEN
-                f_qsws_veg  = 0.0_wp
-                f_qsws_soil = 0.0_wp
-                f_qsws_liq  = rho_lv / r_a(j,i)
-             ELSEIF ( pave_surface (j,i) )  THEN
-                f_qsws_veg  = 0.0_wp
-                f_qsws_soil = 0.0_wp
-                f_qsws_liq  = rho_lv * c_liq(j,i) / r_a(j,i)
-             ELSE
-                f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/     &
-                              (r_a(j,i) + r_canopy(j,i))
-                f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +     &
-                                                          r_soil(j,i))
-                f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
-             ENDIF
-!
-!--          If soil moisture is below wilting point, plants do no longer
-!--          transpirate.
-!              IF ( m_soil(k,j,i) < m_wilt(j,i) )  THEN
-!                 f_qsws_veg = 0.0_wp
-!              ENDIF
-
-             f_shf  = rho_cp / r_a(j,i)
-             f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
-
-!
-!--          Calculate derivative of q_s for Taylor series expansion
-             e_s_dt = e_s * ( 17.269_wp / (t_surface(j,i) - 35.86_wp) -        &
-                              17.269_wp*(t_surface(j,i) - 273.16_wp)           &
-                              / (t_surface(j,i) - 35.86_wp)**2 )
-
-             dq_s_dt = 0.622_wp * e_s_dt / surface_pressure
-
-!
-!--          Add LW up so that it can be removed in prognostic equation
-             rad_net_l(j,i) = rad_net(j,i) + rad_lw_out(nzb,j,i)
-
-!
-!--          Calculate new skin temperature
-             IF ( humidity )  THEN
-#if defined ( __rrtmg )
-!
-!--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)             &
-                         * t_surface(j,i) - rad_lw_out(nzb,j,i)                &
-                         + f_shf * pt1 + f_qsws * ( qv1 - q_s                  &
-                         + dq_s_dt * t_surface(j,i) ) + lambda_surface         &
-                         * t_soil(nzb_soil,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = rad_lw_out_change_0(j,i) + f_qsws * dq_s_dt           &
-                         + lambda_surface + f_shf / exn
-#else
-
-!
-!--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb                    &
-                         * t_surface(j,i) ** 4                                 &
-                         + f_shf * pt1 + f_qsws * ( qv1                        &
-                         - q_s + dq_s_dt * t_surface(j,i) )                    &
-                         + lambda_surface * t_soil(nzb_soil,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = 4.0_wp * sigma_sb * t_surface(j,i) ** 3 + f_qsws      &
-                         * dq_s_dt + lambda_surface + f_shf / exn
- 
-#endif
-             ELSE
-
-#if defined ( __rrtmg )
-!
-!--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)             &
-                         * t_surface(j,i) - rad_lw_out(nzb,j,i)                &
-                         + f_shf * pt1  + lambda_surface                       &
-                         * t_soil(nzb_soil,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = rad_lw_out_change_0(j,i) + lambda_surface + f_shf / exn
-#else
-
-!
-!--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb                    &
-                          * t_surface(j,i) ** 4 + f_shf * pt1                  &
-                          + lambda_surface * t_soil(nzb_soil,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = 4.0_wp * sigma_sb * t_surface(j,i) ** 3               &
-                         + lambda_surface + f_shf / exn
-#endif
-             ENDIF
-
-             tend = 0.0_wp
-
-!
-!--          Implicit solution when the surface layer has no heat capacity,
-!--          otherwise use RK3 scheme.
-             t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface_tmp *    &
-                                t_surface(j,i) ) / ( c_surface_tmp + coef_2    &
+!--       f1: correction for incoming shortwave radiation (stomata close at 
+!--       night)
+          f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k,j,i) + 0.05_wp ) /        &
+                           (0.81_wp * (0.004_wp * rad_sw_in(k,j,i)             &
+                            + 1.0_wp)) )
+
+
+
+!
+!--       f2: correction for soil moisture availability to plants (the 
+!--       integrated soil moisture must thus be considered here)
+!--       f2 = 0 for very dry soils
+          m_total = 0.0_wp
+          DO  ks = nzb_soil, nzt_soil
+              m_total = m_total + root_fr(ks,j,i)                              &
+                        * MAX(m_soil(ks,j,i),m_wilt(j,i))
+          ENDDO 
+
+          IF ( m_total > m_wilt(j,i)  .AND.  m_total < m_fc(j,i) )  THEN
+             f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
+          ELSEIF ( m_total >= m_fc(j,i) )  THEN
+             f2 = 1.0_wp
+          ELSE
+             f2 = 1.0E-20_wp
+          ENDIF
+
+!
+!--       Calculate water vapour pressure at saturation 
+          e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface(j,i)        &
+                        - 273.16_wp ) / ( t_surface(j,i) - 35.86_wp ) )
+
+!
+!--       f3: correction for vapour pressure deficit
+          IF ( g_d(j,i) /= 0.0_wp )  THEN
+!
+!--          Calculate vapour pressure
+             e  = qv1 * surface_pressure / 0.622_wp
+             f3 = EXP ( -g_d(j,i) * (e_s - e) )
+          ELSE
+             f3 = 1.0_wp
+          ENDIF
+
+!
+!--       Calculate canopy resistance. In case that c_veg is 0 (bare soils),
+!--       this calculation is obsolete, as r_canopy is not used below.
+!--       To do: check for very dry soil -> r_canopy goes to infinity
+          r_canopy(j,i) = r_canopy_min(j,i) / (lai(j,i) * f1 * f2 * f3         &
+                                          + 1.0E-20_wp)
+
+!
+!--       Third step: calculate bare soil resistance r_soil. The Clapp & 
+!--       Hornberger parametrization does not consider c_veg.
+          IF ( soil_type_2d(j,i) /= 7 )  THEN
+             m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *        &
+                     m_res(j,i)
+          ELSE
+             m_min = m_wilt(j,i)
+          ENDIF
+
+          f2 = ( m_soil(nzb_soil,j,i) - m_min ) / ( m_fc(j,i) - m_min )
+          f2 = MAX(f2,1.0E-20_wp)
+          f2 = MIN(f2,1.0_wp)
+
+          r_soil(j,i) = r_soil_min(j,i) / f2
+
+!
+!--       Calculate the maximum possible liquid water amount on plants and
+!--       bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
+!--       assumed, while paved surfaces might hold up 1 mm of water. The 
+!--       liquid water fraction for paved surfaces is calculated after 
+!--       Noilhan & Planton (1989), while the ECMWF formulation is used for
+!--       vegetated surfaces and bare soils.
+          IF ( pave_surface(j,i) )  THEN
+             m_liq_eb_max = m_max_depth * 5.0_wp
+             c_liq(j,i) = MIN( 1.0_wp, (m_liq_eb(j,i) / m_liq_eb_max)**0.67 )
+          ELSE
+             m_liq_eb_max = m_max_depth * ( c_veg(j,i) * lai(j,i)              &
+                            + (1.0_wp - c_veg(j,i)) )
+             c_liq(j,i) = MIN( 1.0_wp, m_liq_eb(j,i) / m_liq_eb_max )
+          ENDIF
+
+!
+!--       Calculate saturation specific humidity
+          q_s = 0.622_wp * e_s / surface_pressure
+
+!
+!--       In case of dewfall, set evapotranspiration to zero
+!--       All super-saturated water is then removed from the air
+          IF ( humidity  .AND.  q_s <= qv1 )  THEN
+             r_canopy(j,i) = 0.0_wp
+             r_soil(j,i)   = 0.0_wp
+          ENDIF
+
+!
+!--       Calculate coefficients for the total evapotranspiration 
+!--       In case of water surface, set vegetation and soil fluxes to zero.
+!--       For pavements, only evaporation of liquid water is possible.
+          IF ( water_surface(j,i) )  THEN
+             f_qsws_veg  = 0.0_wp
+             f_qsws_soil = 0.0_wp
+             f_qsws_liq  = rho_lv / r_a(j,i)
+          ELSEIF ( pave_surface (j,i) )  THEN
+             f_qsws_veg  = 0.0_wp
+             f_qsws_soil = 0.0_wp
+             f_qsws_liq  = rho_lv * c_liq(j,i) / r_a(j,i)
+          ELSE
+             f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/        &
+                           (r_a(j,i) + r_canopy(j,i))
+             f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +        &
+                                                             r_soil(j,i))
+             f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
+          ENDIF
+!
+!--       If soil moisture is below wilting point, plants do no longer
+!--       transpirate.
+!           IF ( m_soil(k,j,i) < m_wilt(j,i) )  THEN
+!              f_qsws_veg = 0.0_wp
+!           ENDIF
+
+          f_shf  = rho_cp / r_a(j,i)
+          f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
+
+!
+!--       Calculate derivative of q_s for Taylor series expansion
+          e_s_dt = e_s * ( 17.269_wp / (t_surface(j,i) - 35.86_wp) -           &
+                           17.269_wp*(t_surface(j,i) - 273.16_wp)              &
+                           / (t_surface(j,i) - 35.86_wp)**2 )
+
+          dq_s_dt = 0.622_wp * e_s_dt / surface_pressure
+
+!
+!--       Add LW up so that it can be removed in prognostic equation
+          rad_net_l(j,i) = rad_net(j,i) + rad_lw_out(nzb,j,i)
+
+!
+!--       Calculate new skin temperature
+          IF ( humidity )  THEN
+
+!
+!--          Numerator of the prognostic equation
+             coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)                &
+                      * t_surface(j,i) - rad_lw_out(nzb,j,i)                   &
+                      + f_shf * pt1 + f_qsws * ( qv1 - q_s                     &
+                      + dq_s_dt * t_surface(j,i) ) + lambda_surface            &
+                      * t_soil(nzb_soil,j,i)
+
+!
+!--          Denominator of the prognostic equation
+             coef_2 = rad_lw_out_change_0(j,i) + f_qsws * dq_s_dt              &
+                      + lambda_surface + f_shf / exn
+          ELSE
+
+!
+!--          Numerator of the prognostic equation
+             coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)                &
+                      * t_surface(j,i) - rad_lw_out(nzb,j,i)                   &
+                      + f_shf * pt1  + lambda_surface                          &
+                      * t_soil(nzb_soil,j,i)
+
+!
+!--          Denominator of the prognostic equation
+             coef_2 = rad_lw_out_change_0(j,i) + lambda_surface + f_shf / exn
+
+          ENDIF
+
+          tend = 0.0_wp
+
+!
+!--       Implicit solution when the surface layer has no heat capacity,
+!--       otherwise use RK3 scheme.
+          t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface_tmp *       &
+                             t_surface(j,i) ) / ( c_surface_tmp + coef_2       &
                                 * dt_3d * tsc(2) ) 
 
 !
-!--          Add RK3 term
-             IF ( c_surface_tmp /= 0.0_wp )  THEN
-
-                t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)           &
-                                   * tt_surface_m(j,i)
-
-!
-!--             Calculate true tendency
-                tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)     &
-                       * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
-!
-!--             Calculate t_surface tendencies for the next Runge-Kutta step
-                IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                   IF ( intermediate_timestep_count == 1 )  THEN
-                      tt_surface_m(j,i) = tend
-                   ELSEIF ( intermediate_timestep_count <                      &
-                            intermediate_timestep_count_max )  THEN
-                      tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp        &
-                                          * tt_surface_m(j,i)
-                   ENDIF
+!--       Add RK3 term
+          IF ( c_surface_tmp /= 0.0_wp )  THEN
+
+             t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)              &
+                                * tt_surface_m(j,i)
+
+!
+!--          Calculate true tendency
+             tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)        &
+                    * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
+!
+!--          Calculate t_surface tendencies for the next Runge-Kutta step
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   tt_surface_m(j,i) = tend
+                ELSEIF ( intermediate_timestep_count <                         &
+                         intermediate_timestep_count_max )  THEN
+                   tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp           &
+                                       * tt_surface_m(j,i)
                 ENDIF
              ENDIF
-
-!
-!--          In case of fast changes in the skin temperature, it is possible to
-!--          update the radiative fluxes independently from the prescribed
-!--          radiation call frequency. This effectively prevents oscillations,
-!--          especially when setting skip_time_do_radiation /= 0. The threshold
-!--          value of 0.2 used here is just a first guess. This method should be
-!--          revised in the future as tests have shown that the threshold is 
-!--          often reached, when no oscillations would occur (causes immense
-!--          computing time for the radiation code).
-             IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp  .AND.     &
-                  unscheduled_radiation_calls )  THEN
-                force_radiation_call_l = .TRUE.
+          ENDIF
+
+!
+!--       In case of fast changes in the skin temperature, it is possible to
+!--       update the radiative fluxes independently from the prescribed
+!--       radiation call frequency. This effectively prevents oscillations,
+!--       especially when setting skip_time_do_radiation /= 0. The threshold
+!--       value of 0.2 used here is just a first guess. This method should be
+!--       revised in the future as tests have shown that the threshold is 
+!--       often reached, when no oscillations would occur (causes immense
+!--       computing time for the radiation code).
+          IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp  .AND.        &
+               unscheduled_radiation_calls )  THEN
+             force_radiation_call_l = .TRUE.
+          ENDIF
+
+          pt(k,j,i) = t_surface_p(j,i) / exn
+
+!
+!--       Calculate fluxes
+          rad_net_l(j,i)   = rad_net_l(j,i) + rad_lw_out_change_0(j,i)         &
+                             * t_surface(j,i) - rad_lw_out(nzb,j,i)            &
+                             - rad_lw_out_change_0(j,i) * t_surface_p(j,i)
+
+          rad_net(j,i) = rad_net_l(j,i)
+          rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i) + rad_lw_out_change_0(j,i) &
+                                * ( t_surface_p(j,i) - t_surface(j,i) )
+
+          ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)                  &
+                           - t_soil(nzb_soil,j,i))
+
+          shf_eb(j,i)    = - f_shf * ( pt1 - pt(k,j,i) )
+
+          shf(j,i) = shf_eb(j,i) / rho_cp
+
+          IF ( humidity )  THEN
+             qsws_eb(j,i)  = - f_qsws    * ( qv1 - q_s + dq_s_dt               &
+                             * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )
+
+             qsws(j,i) = qsws_eb(j,i) / rho_lv
+
+             qsws_veg_eb(j,i)  = - f_qsws_veg  * ( qv1 - q_s                   &
+                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
+                                 * t_surface_p(j,i) )
+
+             qsws_soil_eb(j,i) = - f_qsws_soil * ( qv1 - q_s                   &
+                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
+                                 * t_surface_p(j,i) )
+
+             qsws_liq_eb(j,i)  = - f_qsws_liq  * ( qv1 - q_s                   &
+                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
+                                 * t_surface_p(j,i) )
+          ENDIF
+
+!
+!--       Calculate the true surface resistance
+          IF ( qsws_eb(j,i) == 0.0_wp )  THEN
+             r_s(j,i) = 1.0E10_wp
+          ELSE
+             r_s(j,i) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
+                        * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )        &
+                        / qsws_eb(j,i) - r_a(j,i)
+          ENDIF
+
+!
+!--       Calculate change in liquid water reservoir due to dew fall or 
+!--       evaporation of liquid water
+          IF ( humidity )  THEN
+!
+!--          If precipitation is activated, add rain water to qsws_liq_eb
+!--          and qsws_soil_eb according the the vegetation coverage.
+!--          precipitation_rate is given in mm.
+             IF ( precipitation )  THEN
+
+!
+!--             Add precipitation to liquid water reservoir, if possible.
+!--             Otherwise, add the water to soil. In case of
+!--             pavements, the exceeding water amount is implicitely removed 
+!--             as runoff as qsws_soil_eb is then not used in the soil model
+                IF ( m_liq_eb(j,i) /= m_liq_eb_max )  THEN
+                   qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                         &
+                                    + c_veg(j,i) * prr(k,j,i) * hyrho(k)       &
+                                    * 0.001_wp * rho_l * l_v
+                ELSE
+                   qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                       &
+                                     + c_veg(j,i) * prr(k,j,i) * hyrho(k)      &
+                                     * 0.001_wp * rho_l * l_v
+                ENDIF
+
+!--             Add precipitation to bare soil according to the bare soil
+!--             coverage.
+                qsws_soil_eb(j,i) = qsws_soil_eb(j,i) + (1.0_wp                &
+                                    - c_veg(j,i)) * prr(k,j,i) * hyrho(k)      &
+                                    * 0.001_wp * rho_l * l_v
              ENDIF
 
-             pt(k,j,i) = t_surface_p(j,i) / exn
-
-!
-!--          Calculate fluxes
-#if defined ( __rrtmg )
-             rad_net_l(j,i)   = rad_net_l(j,i) + rad_lw_out_change_0(j,i)      &
-                                * t_surface(j,i) - rad_lw_out(nzb,j,i)         &
-                                - rad_lw_out_change_0(j,i) * t_surface_p(j,i)
-
-             IF ( rrtm_idrv == 1 )  THEN
-                rad_net(j,i) = rad_net_l(j,i)
-                rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i)                      &
-                                      + rad_lw_out_change_0(j,i)               &
-                                      * ( t_surface_p(j,i) - t_surface(j,i) )
+!
+!--          If the air is saturated, check the reservoir water level
+             IF ( qsws_eb(j,i) < 0.0_wp )  THEN
+
+!
+!--             Check if reservoir is full (avoid values > m_liq_eb_max)
+!--             In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
+!--             case qsws_veg_eb is zero anyway (because c_liq = 1),       
+!--             so that tend is zero and no further check is needed
+                IF ( m_liq_eb(j,i) == m_liq_eb_max )  THEN
+                   qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                       &
+                                        + qsws_liq_eb(j,i)
+
+                   qsws_liq_eb(j,i)  = 0.0_wp
+                ENDIF
+
+!
+!--             In case qsws_veg_eb becomes negative (unphysical behavior), 
+!--             let the water enter the liquid water reservoir as dew on the
+!--             plant
+                IF ( qsws_veg_eb(j,i) < 0.0_wp )  THEN
+                   qsws_liq_eb(j,i) = qsws_liq_eb(j,i) + qsws_veg_eb(j,i)
+                   qsws_veg_eb(j,i) = 0.0_wp
+                ENDIF
+             ENDIF                    
+  
+             tend = - qsws_liq_eb(j,i) * drho_l_lv
+             m_liq_eb_p(j,i) = m_liq_eb(j,i) + dt_3d * ( tsc(2) * tend         &
+                                                + tsc(3) * tm_liq_eb_m(j,i) )
+
+!
+!--          Check if reservoir is overfull -> reduce to maximum
+!--          (conservation of water is violated here)
+             m_liq_eb_p(j,i) = MIN(m_liq_eb_p(j,i),m_liq_eb_max)
+
+!
+!--          Check if reservoir is empty (avoid values < 0.0)
+!--          (conservation of water is violated here)
+             m_liq_eb_p(j,i) = MAX(m_liq_eb_p(j,i),0.0_wp)
+
+
+!
+!--          Calculate m_liq_eb tendencies for the next Runge-Kutta step
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                   tm_liq_eb_m(j,i) = tend
+                ELSEIF ( intermediate_timestep_count <                         &
+                         intermediate_timestep_count_max )  THEN
+                   tm_liq_eb_m(j,i) = -9.5625_wp * tend + 5.3125_wp            &
+                                    * tm_liq_eb_m(j,i)
+                ENDIF
              ENDIF
+
+          ENDIF
+
+       ENDDO
+    ENDDO
+
+!
+!-- Make a logical OR for all processes. Force radiation call if at
+!-- least one processor reached the threshold change in skin temperature
+    IF ( unscheduled_radiation_calls  .AND.  intermediate_timestep_count       &
+         == intermediate_timestep_count_max-1 )  THEN
+#if defined( __parallel )
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,    &
+                           1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
 #else
-             rad_net_l(j,i)   = rad_net_l(j,i) + 3.0_wp * sigma_sb             &
-                                * t_surface(j,i)**4 - 4.0_wp * sigma_sb        &
-                                * t_surface(j,i)**3 * t_surface_p(j,i)
+       force_radiation_call = force_radiation_call_l
 #endif
-
-             ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)               &
-                              - t_soil(nzb_soil,j,i))
-
-             shf_eb(j,i)    = - f_shf * ( pt1 - pt(k,j,i) )
-
-             shf(j,i) = shf_eb(j,i) / rho_cp
-
-             IF ( humidity )  THEN
-                qsws_eb(j,i)  = - f_qsws    * ( qv1 - q_s + dq_s_dt            &
-                                * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )
-
-                qsws(j,i) = qsws_eb(j,i) / rho_lv
-
-                qsws_veg_eb(j,i)  = - f_qsws_veg  * ( qv1 - q_s                &
-                                    + dq_s_dt * t_surface(j,i) - dq_s_dt       &
-                                    * t_surface_p(j,i) )
-
-                qsws_soil_eb(j,i) = - f_qsws_soil * ( qv1 - q_s                &
-                                    + dq_s_dt * t_surface(j,i) - dq_s_dt       &
-                                    * t_surface_p(j,i) )
-
-                qsws_liq_eb(j,i)  = - f_qsws_liq  * ( qv1 - q_s                &
-                                    + dq_s_dt * t_surface(j,i) - dq_s_dt       &
-                                    * t_surface_p(j,i) )
-             ENDIF
-
-!
-!--          Calculate the true surface resistance
-             IF ( qsws_eb(j,i) == 0.0_wp )  THEN
-                r_s(j,i) = 1.0E10_wp
-             ELSE
-                r_s(j,i) = - rho_lv * ( qv1 - q_s + dq_s_dt                    &
-                           * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )     &
-                           / qsws_eb(j,i) - r_a(j,i)
-             ENDIF
-
-!
-!--          Calculate change in liquid water reservoir due to dew fall or 
-!--          evaporation of liquid water
-             IF ( humidity )  THEN
-!
-!--             If precipitation is activated, add rain water to qsws_liq_eb
-!--             and qsws_soil_eb according the the vegetation coverage.
-!--             precipitation_rate is given in mm.
-                IF ( precipitation )  THEN
-
-!
-!--                Add precipitation to liquid water reservoir, if possible.
-!--                Otherwise, add the water to soil. In case of
-!--                pavements, the exceeding water amount is implicitely removed 
-!--                as runoff as qsws_soil_eb is then not used in the soil model
-                   IF ( m_liq_eb(j,i) /= m_liq_eb_max )  THEN
-                      qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                      &
-                                       + c_veg(j,i) * prr(k,j,i) * hyrho(k)    &
-                                       * 0.001_wp * rho_l * l_v
-                   ELSE
-                      qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                    &
-                                        + c_veg(j,i) * prr(k,j,i) * hyrho(k)   &
-                                        * 0.001_wp * rho_l * l_v
-                   ENDIF
-
-!--                Add precipitation to bare soil according to the bare soil
-!--                coverage.
-                   qsws_soil_eb(j,i) = qsws_soil_eb(j,i) + (1.0_wp             &
-                                       - c_veg(j,i)) * prr(k,j,i) * hyrho(k)   &
-                                       * 0.001_wp * rho_l * l_v
-                ENDIF
-
-!
-!--             If the air is saturated, check the reservoir water level
-                IF ( qsws_eb(j,i) < 0.0_wp )  THEN
-
-!
-!--                Check if reservoir is full (avoid values > m_liq_eb_max)
-!--                In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
-!--                case qsws_veg_eb is zero anyway (because c_liq = 1),       
-!--                so that tend is zero and no further check is needed
-                   IF ( m_liq_eb(j,i) == m_liq_eb_max )  THEN
-                      qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                    &
-                                           + qsws_liq_eb(j,i)
-
-                      qsws_liq_eb(j,i)  = 0.0_wp
-                   ENDIF
-
-!
-!--                In case qsws_veg_eb becomes negative (unphysical behavior), 
-!--                let the water enter the liquid water reservoir as dew on the
-!--                plant
-                   IF ( qsws_veg_eb(j,i) < 0.0_wp )  THEN
-                      qsws_liq_eb(j,i) = qsws_liq_eb(j,i) + qsws_veg_eb(j,i)
-                      qsws_veg_eb(j,i) = 0.0_wp
-                   ENDIF
-                ENDIF                    
-  
-                tend = - qsws_liq_eb(j,i) * drho_l_lv
-
-                m_liq_eb_p(j,i) = m_liq_eb(j,i) + dt_3d * ( tsc(2) * tend      &
-                                                   + tsc(3) * tm_liq_eb_m(j,i) )
-
-!
-!--             Check if reservoir is overfull -> reduce to maximum
-!--             (conservation of water is violated here)
-                m_liq_eb_p(j,i) = MIN(m_liq_eb_p(j,i),m_liq_eb_max)
-
-!
-!--             Check if reservoir is empty (avoid values < 0.0)
-!--             (conservation of water is violated here)
-                m_liq_eb_p(j,i) = MAX(m_liq_eb_p(j,i),0.0_wp)
-
-
-!
-!--             Calculate m_liq_eb tendencies for the next Runge-Kutta step
-                IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                   IF ( intermediate_timestep_count == 1 )  THEN
-                      tm_liq_eb_m(j,i) = tend
-                   ELSEIF ( intermediate_timestep_count <                      &
-                            intermediate_timestep_count_max )  THEN
-                      tm_liq_eb_m(j,i) = -9.5625_wp * tend + 5.3125_wp         &
-                                      * tm_liq_eb_m(j,i)
-                   ENDIF
-                ENDIF
-
-             ENDIF
-
-          ENDDO
-       ENDDO
-
-!
-!--    Make a logical OR for all processes. Force radiation call if at
-!--    least one processor reached the threshold change in skin temperature
-       IF ( unscheduled_radiation_calls  .AND.  intermediate_timestep_count    &
-            == intermediate_timestep_count_max-1 )  THEN
-#if defined( __parallel )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,    &
-                              1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
-#else
-          force_radiation_call = force_radiation_call_l
-#endif
-          force_radiation_call_l = .FALSE.
-       ENDIF
-
-!
-!--    Calculate surface specific humidity
-       IF ( humidity )  THEN
-          CALL calc_q_surface
-       ENDIF
-
-!
-!--    Calculate new roughness lengths (for water surfaces only)
-       CALL calc_z0_water_surface
-
-
-    END SUBROUTINE lsm_energy_balance
+       force_radiation_call_l = .FALSE.
+    ENDIF
+
+!
+!-- Calculate surface specific humidity
+    IF ( humidity )  THEN
+       CALL calc_q_surface
+    ENDIF
+
+!
+!-- Calculate new roughness lengths (for water surfaces only)
+    CALL calc_z0_water_surface
+
+
+ END SUBROUTINE lsm_energy_balance
+
 
 !------------------------------------------------------------------------------!
